Foreman Remote Execution - Bug #21168

Can't create a location
10/02/2017 09:46 AM - Ori Rabin

Status: Closed

Priority: High

Assignee: Ivan Necas

Category:

Target version: foreman_remote_execution 1.3.6

Difficulty: Fixed in Releases:

Triaged: Found in Releases:

Bugzilla link: Red Hat JIRA:

Pull request: https://github.com/theforeman/foreman_r
emote_execution/pull/277,
https://github.com/theforeman/foreman_r
emote_execution/pull/284

Description

Trying to create a location silently fails, the server log only shows: "Failed to save: "
In the taxonomy controller using save! instead of save gives: ActiveRecord::RecordInvalid: Validation failed: Taxonomy has already
been taken.

The sql logs show this insert right before rollback:

2017-10-02T16:41:58 471cb7ee [sqgl] [D] SQL (0.6ms) INSERT INTO "taxable_taxonomies" ("taxonomy_
id", "taxable_id", "taxable_type", "created_at", "updated_at") VALUES ($1, $2, $3, $4, $5) RETURNI
NG "id" [["taxonomy_id", 23], ["taxable_id", 104], ["taxable_type", "JobTemplate"], ["created_at"
"2017-10-02 13:41:58.701252"], ["updated_at", "2017-10-02 13:41:58.701252"]]

2017-10-02T16:41:58 471cb7ee [sgl] [D] TaxableTaxonomy Exists (0.9ms) SELECT 1 AS one FROM "ta
xable_taxonomies" WHERE "taxable_taxonomies"."taxonomy_id" = $1 AND "taxable_taxonomies"."taxable_
id" = $2 AND "taxable_taxonomies"."taxable_type" = $3 LIMIT $4 [["taxonomy_id", 23], ["taxable_id
", 100], ["taxable_type", "JobTemplate"], ["LIMIT", 1]]

2017-10-02T16:41:59 471cb7ee [sgl] [D] (0.4ms) ROLLBACK

After deleting all of the job templates (including the seeded ones) the location can be saved.

Related issues:

Related to Foreman Remote Execution - Bug #20427: REX doesnt start with rails 5 Closed 07/27/2017
Related to Foreman Remote Execution - Bug #11805: error creating organization... Closed 09/14/2015
Blocked by Foreman - Bug #11825: Adding template types from plugins doesn't w... Closed 09/15/2015

Associated revisions

Revision 806f03af - 10/06/2017 05:02 AM - lvan Necas
Fixes #21168 - Workaround for rails5 callbacks (#277)

Revision afb7a4a3 - 10/13/2017 11:57 AM - lvan Necas

Refs #21168 - raise => false only for Rails 5 (#284)

Rails 4 doesn't raise any issue when callback is not found and it
doesn't even know the raise option. Due to this, it considers the

additional option being a sign of need for re-definition of the
original callback, instead of just making it as skipped.

This patch sets the “raise => false™ only for Rails 5, where it's
needed.

History

#1 - 10/02/2017 10:08 AM - Adam Ruzicka
While trying to reproduce this | encountered a possibly related error

pry (main)> loc.save!
ActiveRecord::InvalidForeignKey: PG::ForeignKeyViolation: ERROR: insert or update on table "taxable_taxonomie
s" violates foreign key constraint "taxable_taxonomies_taxonomy_id_fk"
DETAIL: Key (taxonomy_id)=(5) is not present in table "taxonomies".

INSERT INTO "taxable_taxonomies" ("taxonomy_id", "taxable_id", "taxable_type", "created_at", "updated_at") V
ALUES ($1, $2, $3, $4, $5) RETURNING "id"
from /home/aruzicka/.rbenv/versions/2.4.1/1ib/ruby/gems/2.4.0/gems/activerecord-5.0.6/1ib/active_record/connec
tion_adapters/postgresql_adapter.rb:598:in ‘async_exec'

#2 - 10/02/2017 03:14 PM - Ivan Necas
- Priority changed from Normal to High

#3 - 10/04/2017 09:29 AM - Adam Ruzicka
- Related to Bug #20427: REX doesnt start with rails 5 added

#4 - 10/04/2017 10:03 AM - Ivan Necas

- Related to Bug #11805: error creating organization in assign_default_templates added

#5 - 10/04/2017 10:04 AM - Ivan Necas
- Blocked by Bug #11825: Adding template types from plugins doesn't work with taxonomies added

#6 - 10/05/2017 06:09 AM - The Foreman Bot
- Status changed from New to Ready For Testing
- Assignee set to Ivan Necas

- Pull request https://github.com/theforeman/foreman_remote_execution/pull/277 added

#7 - 10/06/2017 05:12 AM - lvan Necas
- Status changed from Ready For Testing to Closed
- % Done changed from 0 to 100

Applied in changeset foreman_plugin|806f03af1a67c85990404e00e6f4250868bc372b.

#8 - 10/13/2017 10:14 AM - The Foreman Bot

- Pull request https://github.com/theforeman/foreman_remote_execution/pull/284 added

#9 - 10/13/2017 12:34 PM - Ivan Necas

- translation missing: en.field_release set to 321
